<?php
/**
 * Created by PhpStorm.
 * User: fffff
 * Date: 2018/12/7
 * Time: 17:05
 */

namespace App\Http\Controllers\Welfare\WeChat;

use App\Http\Controllers\Controller;
use App\Repositories\Common\TemplateConfigRepositories;
use App\Services\Welfare\WeChat\TemplatePushService;
use Illuminate\Http\Request;

class TemplatePushController extends Controller
{
    public function __construct()
    {
        defined('COMPANY_SOURCE') ?: define('COMPANY_SOURCE', 'welfare');
    }

    /**
     * @param Request $request
     * @param TemplateConfigRepositories $templateConfigRepositories
     * @param TemplatePushService $templatePushService
     * @return bool
     * @throws \App\Exceptions\SystemException
     * @throws \EasyWeChat\Kernel\Exceptions\InvalidArgumentException
     * @throws \Psr\SimpleCache\InvalidArgumentException
     */
    public function sendTemplateMsg(Request $request, TemplateConfigRepositories $templateConfigRepositories, TemplatePushService $templatePushService)
    {
        $templateId = $templatePushService->getTemplateId($templateConfigRepositories, COMPANY_SOURCE, $request->get('type'));
        $templatePushService->push($request->get('user-openid'), $templateId );
        return true;
    }
}