<?php

namespace App\Http\Middleware;

use App\Exceptions\AuthenticateException;
use App\Services\Common\LoginUser;
use App\Services\Common\UserInfo;
use Closure;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Cache;
use Illuminate\Support\Facades\Redis;

class AuthCheck
{
    /**
     * @param Request $request
     * @param Closure $next
     * @return mixed
     * @throws AuthenticateException
     */
    public function handle(Request $request, Closure $next)
    {
//        $tokenName = 'token';
//
//        if (!$request->hasHeader($tokenName)
//            || ($token = $request->header($tokenName) && empty($token))
//        ) {
//            throw new AuthenticateException('请登录');
//        }
//
//        try {
//            $userInfo = $this->getUserInfo($token);
//            LoginUser::getInstance()->setUserInfo($userInfo);
//        } catch (\Exception $e) {
//            throw new AuthenticateException('请登录');
//        }

        return $next($request);
    }

    /**
     * @param $token
     * @return mixed
     * @throws AuthenticateException
     */
    private function getUserInfo($token)
    {
        $userInfo = Cache::store('redis')->get($token);
        if (empty($userInfo)) {
            throw new AuthenticateException();
        }

        return $userInfo;
    }
}
