<?php
/**
 * Created by PhpStorm.
 * User: wyung
 * Date: 2018/11/21
 * Time: 下午3:35
 */

namespace App\Services;

class BaseService
{

    /**
     * @param $url
     * @param $params
     * @param null $headers
     * @param string $request_method
     * @param bool $post_file
     * @return mixed
     */
    public function http_request($url, $params, $headers = NULL, $request_method = 'post', $post_file = false)
    {
        $oCurl = curl_init();
        if (stripos($url, "https://") !== FALSE) {
            curl_setopt($oCurl, CURLOPT_SSL_VERIFYPEER, FALSE);
            curl_setopt($oCurl, CURLOPT_SSL_VERIFYHOST, false);
            curl_setopt($oCurl, CURLOPT_SSLVERSION, 1); //CURL_SSLVERSION_TLSv1
        }
        if (PHP_VERSION_ID >= 50500 && class_exists('\CURLFile')) {
            $is_curlFile = true;
        } else {
            $is_curlFile = false;
            if (defined('CURLOPT_SAFE_UPLOAD')) {
                curl_setopt($oCurl, CURLOPT_SAFE_UPLOAD, false);
            }
        }
        //Log::info('请求报文：' . $strPOST);
        curl_setopt($oCurl, CURLOPT_RETURNTRANSFER, 1);
        if ($request_method == 'post') {
            $strPOST = json_encode($params);
            curl_setopt($oCurl, CURLOPT_POST, true);
            curl_setopt($oCurl, CURLOPT_POSTFIELDS, $strPOST);
        } else {
            $param_str = '?';
            foreach ($params as $key => $value) {
                $param_str .= $key . '=' . $value . '&';
            }
            $param_str = substr($param_str, 0, strlen($param_str) - 1);
            $url = $url . $param_str;
        }
        curl_setopt($oCurl, CURLOPT_URL, $url);
        if ($headers) {
            curl_setopt($oCurl, CURLOPT_HTTPHEADER, $headers);
        }
        $sContent = curl_exec($oCurl);
        $aStatus = curl_getinfo($oCurl);
        curl_close($oCurl);
        return json_decode($sContent, true);
    }


    /**
     * 获取session_key
     * @param $appid
     * @param $secret
     * @param $code
     * @param string $grant_type
     * @return string
     */
    public function get_session_key($appid,$secret,$code,$grant_type = 'authorization_code')
    {
        $url = 'https://api.weixin.qq.com/sns/jscode2session';
        $params = array(
            'appid' => $appid,
            'secret' => $secret,
            'js_code' => $code,
            'grant_type' => $grant_type,
        );
        $return_data = $this->http_request($url,$params,null,'get');
        return $return_data;
    }
}