<?php
/**
 * Created by PhpStorm.
 * User: fffff
 * Date: 2018/12/10
 * Time: 17:55
 */

namespace App\Services\Welfare\WeChat;

use App\Repositories\Common\TemplateConfigRepositories;
use App\Services\Common\WeChat;
use EasyWeChat\Factory;
use Illuminate\Http\Request;

class TemplatePushService
{
    protected $easyWeChat;

    public function __construct()
    {
        $this->easyWeChat = WeChat::getInstance()->getEasyWeChatInstance();
    }

    /**
     * @param Request $request
     * @return bool
     * @throws \App\Exceptions\SystemException
     * @throws \EasyWeChat\Kernel\Exceptions\InvalidArgumentException
     * @throws \Psr\SimpleCache\InvalidArgumentException
     */
    public function push($userOpenid, $templateId)
    {


        WeChat::getInstance()->getToken();
        $template_message = $this->easyWeChat->template_message;

        $requestData = [
            'touser' => $userOpenid,
            'template_id' => $templateId,
            'url' => '' ,  //小程序跳转的连接
            'data' => [
                'key1' => 'VALUE',
                'key2' => 'VALUE2',
            ]
        ];

        $response = $template_message->send($requestData);
        return true;
    }

    public function getTemplateId(TemplateConfigRepositories $templateConfigRepositories, $companyName, $type)
    {
        $templateId = $templateConfigRepositories->model()
            ->where(['company_name' => $companyName, 'type' => $type])
            ->fields('template_id')
            ->first();
        return $templateId;
    }
}
